# How to generate the sample data in this folder

The sample data in this folder can be easily generated by debugging the `data_pipeline/etl/score/etl_score_post.py` file
and exporting data using the debugger console. Examples of this exporting are below.

## Why in pickle format?

Exporting as a Pickle file keeps all the metadata about the columns including the data types. If we were to export as CSV then we will need
to code the data types in the test fixtures for all the columns for the comparison to be correct.

## Exporting the test data

First, verify the code works as expected before exporting the data. You will not be able to inspect the data exports as they are in binary.
You will be using the debugger to export the data. Note that it is best to export a small subset of the data for faster test execution.

### create_tile_data test
1. Place a breakpoint in `data_pipeline/etl/score/etl_score_post.py` in the `transform` method right after the call to
`_create_tile_data` and start the debugger running the Generate Post Score command (`generate-score-post`).
1. Partially export the `output_score_county_state_merged_df` and `self.output_score_tiles_df` data to a pickle file once the debugger pauses 
at the breakpoint. Use these sample commands in the debugger console. Note that we are using head and tail to have territories in the sample data.

```python
pd.concat([output_score_county_state_merged_df.head(3), output_score_county_state_merged_df.tail(4)], ignore_index=True).to_pickle('data_pipeline/etl/score/tests/snapshots/create_tile_score_data_input.pkl')
pd.concat([self.output_score_tiles_df.head(3), self.output_score_tiles_df.tail(4)], ignore_index=True).to_pickle('data_pipeline/etl/score/tests/snapshots/create_tile_data_expected.pkl')
```
